<?php

namespace ParrotDb\ObjectModel;

/**
 * Generated by PHPUnit_SkeletonGenerator on 2015-08-18 at 18:18:54.
 */
class PClassTest extends \PHPUnit_Framework_TestCase
{
    /**
     * @var PClass
     */
    protected $object;

    /**
     * Sets up the fixture, for example, opens a network connection.
     * This method is called before a test is executed.
     */
    protected function setUp()
    {
        $this->object = new PClass("Testclass");
        $this->object->addSuperclass("Superclass");
        $this->object->addField("field1");
        $this->object->addFIeld("field2");
        $this->object->addExtentMember(new PObjectId(4), "Test");
    }

    /**
     * Tears down the fixture, for example, closes a network connection.
     * This method is called after a test is executed.
     */
    protected function tearDown()
    {
    }

    

    

    /**
     * @covers ParrotDb\ObjectModel\PClass::addField
     * @todo   Implement testAddField().
     */
    public function testAddField()
    {
        $this->assertFalse($this->object->hasField("field3"));
        $this->object->addField("field3");
        $this->assertTrue($this->object->hasField("field3"));
    }

    /**
     * @covers ParrotDb\ObjectModel\PClass::getFields
     * @todo   Implement testGetFields().
     */
    public function testGetFields()
    {
        $this->assertEquals($this->object->getFields()["field1"], "field1");
        $this->assertEquals($this->object->getFields()["field2"], "field2");
    }

    /**
     * @covers ParrotDb\ObjectModel\PClass::getExtent
     * @todo   Implement testGetExtent().
     */
    public function testGetExtent()
    {
        $this->assertEquals($this->object->getExtent()[4], "Test");
    }

    /**
     * @covers ParrotDb\ObjectModel\PClass::addExtentMember
     * @todo   Implement testAddExtentMember().
     */
    public function testAddExtentMember()
    {
        $this->assertFalse($this->object->isInExtent(new PObjectId(7)));
        $this->object->addExtentMember(new PObjectId(7), "Test2");
        $this->assertTrue($this->object->isInExtent(new PObjectId(7)));
    }

    /**
     * @covers ParrotDb\ObjectModel\PClass::isInExtent
     * @todo   Implement testIsInExtent().
     */
    public function testIsInExtent()
    {
        $this->assertTrue($this->object->isInExtent(new PObjectId(4)));
    }

    /**
     * @covers ParrotDb\ObjectModel\PClass::addSuperclass
     * @todo   Implement testAddSuperclass().
     */
    public function testAddSuperclass()
    {
        $this->assertFalse($this->object->hasSuperclass("NewSuperclass"));
        $this->object->addSuperclass("NewSuperclass");
        $this->assertTrue($this->object->hasSuperclass("NewSuperclass"));
    }

    /**
     * @covers ParrotDb\ObjectModel\PClass::getSuperclasses
     * @todo   Implement testGetSuperclasses().
     */
    public function testGetSuperclasses()
    {
        $this->assertEquals($this->object->getSuperclasses()["Superclass"], "Superclass");
    }
}
